<?php
/**
 * Project: Hankookhospital.co.kr.
 * User: Kyeongdae
 * Date: 2015-07-12
 * Time: 오후 11:50
 */
class admin_menu extends ModuleObject
{
    /**
     * Implement if additional tasks are necessary when installing
     * @return BaseObject
     */
    function moduleInstall() { return $this->createObject(); }

    /**
     * A method to check if successfully installed
     * @return bool
     */
    function checkUpdate()
    {
        //$oDB = &DB::getInstance();
        //$oModuleModel = getModel('module');
        if(!$this->hasModuleListInModuleHandler())
            return true;

        return false;
    }

    /**
     * Execute update
     * @return Object
     */
    function moduleUpdate()
    {
        //$oDB = &DB::getInstance();
        //$oModuleModel = getModel('module');
        $this->injectModuleListInModuleHandler();

        return $this->createObject(0, 'success_updated');
    }

    /** @return Context */
    function getContext() { return Context::getInstance(); }

    private function injectModuleListInModuleHandler()
    {
        $oModuleModel      = getModel('module');
        $oModuleController = getController('module');

        if (!$oModuleModel->getTrigger('moduleHandler.proc', 'admin_menu', 'controller', 'onAfterModuleProc', 'after')) {
            $oModuleController->insertTrigger('moduleHandler.proc', 'admin_menu', 'controller', 'onAfterModuleProc', 'after');
        }
    }

    private function hasModuleListInModuleHandler()
    {
        $oModuleModel = getModel('module');

        if ($oModuleModel->getTrigger('moduleHandler.proc', 'admin_menu', 'controller', 'onAfterModuleProc', 'after')) {
            return true;
        }
    }

    protected function createObject($error = 0, $message = 'success') {
        if(class_exists("BaseObject")) {
            return new BaseObject($error, $message);
        } else {
            return new Object($error, $message);
        }
    }

    protected function getConfig(){
    	/** @var moduleModel $oModuleModel */
	    $oModuleModel = getModel('module');
	    return $oModuleModel->getModuleConfig('admin_menu');
    }

    protected function saveConfig($oAdminConfig) {
    	/** @var moduleController $oModuleController */
	    $oModuleController = getController('module');
	    $oModuleController->insertModuleConfig('admin_menu', $oAdminConfig);
    }
}